''  *** COMPILED WITH PropBasic VERSION 00.00.95a  Apr 26, 2010 ***
                                                             '' ======================================================================
                                                             ''
                                                             ''   File.....PB_TV_Key.pbas
                                                             ''   Purpose...Demo for TV 40*30 and Keybord
                                                             ''   Author.... C. Ebersp?cher
                                                             ''   E-mail....
                                                             ''   Started... 30 04 2010
                                                             ''   Updated... DD MMM YYYY
                                                             ''
                                                             '' ======================================================================


                                                             '' ----------------------------------------------------------------------
                                                             '' Program Description
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------
                                                             '' Conditional Compilation Symbols
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------
                                                             '' Device Settings
                                                             '' ----------------------------------------------------------------------



CON                                                          'DEVICE          P8X32A, XTAL1, PLL16X
  _ClkMode = XTAL1 + PLL16X                                 

  _XInFreq = 5000000                                         'XIN             5_000_000



                                                             '' ----------------------------------------------------------------------
                                                             '' Constants
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------
                                                             '' I/O Pins
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------
                                                             '' Shared (hub) Variables (Byte, Word, Long)
                                                             '' ----------------------------------------------------------------------
' VAR LONG screenadr                                         'screenadr  hub long

' VAR LONG keybuffer                                         'keybuffer  hub long


                                                             '' ----------------------------------------------------------------------
                                                             '' Shared (hub) Data (DATA, WDATA, LDATA, FILE)
                                                             '' ----------------------------------------------------------------------
'Text DATA "This is a string. Please press a key!",0         'Text DATA "This is a string. Please press a key!",0


                                                             '' ----------------------------------------------------------------------
                                                             '' TASK Definitions
                                                             '' ----------------------------------------------------------------------


                                                             '' ----------------------------------------------------------------------
                                                             '' Cog Variables (Long only)
                                                             '' ----------------------------------------------------------------------
' i          var long                                        'i          var long

' screen     var long                                        'screen     var long

' char       var long                                        'char       var long

' pos        var long                                        'pos        var long

' col        var long=0                                      'col        var long=0

' row        var long=0                                      'row        var long=0

' temp       var long                                        'temp       var long

' temp1      var long                                        'temp1      var long

' temp2      var long                                        'temp2      var long

' temp3      var long                                        'temp3      var long

' temp4      var long                                        'temp4      var long

' temp5      var long                                        'temp5      var long

' temp6      var long                                        'temp6      var long

' temp7      var long                                        'temp7      var long


                                                             '' ----------------------------------------------------------------------
                                                             '' SUB/FUNC Definitions
                                                             '' ----------------------------------------------------------------------
' PrtChar    sub 1                                           'PrtChar    sub 1

' NewLine    sub 0                                           'NewLine    sub 0

' PrtDec     sub 1                                           'PrtDec     sub 1

' CursorXY   sub 2                                           'CursorXY   sub 2

' CLS        SUB 0                                           'CLS        SUB 0

' PrtStr     SUB 1                                           'PrtStr     SUB 1



' Key        func 0                                          'Key        func 0

' GetKey     func 0                                          'GetKey     func 0




                                                             '' Put in code to run spin dispatcher
                  '             ASM                          'ASM

'#############################################################
OBJ                                                         
  Keyb:  "Keyboard"                                         
  term: "TvTxth"                                            
  'term1 : "isxtv"                                          
  'f :    "sxfile"                                          
  'key:    "isxkb"                                          
PUB SpinStart                                               
  __OFFSET := @__Init                                       
  CogInit(7, @_LMM_Entry, @__DATASTART)                     
                                                            
                                                            
                                                            
  Keyb.Start(26, 27)                                        
  keybuffer:= Keyb.GetBuffer                                
                                                            
                                                            
  term.start(12,1,1,40,30 )                                 
  term.str(string("Hallo"))                                 
  screenadr:= term.getadr 'Get the startadress of the screenbuffer
 '}                                                         
'###############################################################
                  '             ENDASM                       ' ENDASM




                                                             '' ======================================================================
PUB __Program                                                '  PROGRAM Start LMM
  __OFFSET := @__Init                                       
  CogInit(0, @_LMM_Entry, @__DATASTART)                     
                                                            
DAT                                                         
                  org           0                           
__Init                                                      
__RAM                                                       
                  mov           dira,__InitDirA             
                  mov           outa,__InitOutA             
                  jmp           #_LMM_JUMP                  
                  long          @Start - @__Init            

                                                             '' ======================================================================

Start                                                        'Start:

                                                             '  ' user start-up code

Main                                                         'Main:


                                                             '  ' Main program code goes here
                  mov           __temp2,_1000                '  pause 1000
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0001                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          @__L0001 - @__Init          





__DO_1                                                       '  do

                  mov           i,#"a"                       '  for i= "a" to "z"
__FOR_i_1                                                   

                  mov           char,i                       '     char = i

                  mov           __param1,char                '     PrtChar char
                  jmp           #_LMM_CALL                  
                  long          @PrtChar_ret - @__Init      
                  long          @PrtChar - @__Init          

                  jmp           #_LMM_CALL                   '     newline
                  long          @newline_ret - @__Init      
                  long          @newline - @__Init          

                  mov           __temp2,#30                  '     pause 30
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0002                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          @__L0002 - @__Init          

                  adds          i,#1                         '  next i
                  cmps          i,#"z" WZ, WC               
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__FOR_i_1 - @__Init        
__NEXT_i_1                                                  

                                                             '  'newline
                  mov           i,#"A"                       '  for i= "A" to "Z"
__FOR_i_2                                                   

                  mov           char,i                       '     char = i

                  mov           __param1,char                '     PrtChar char
                  jmp           #_LMM_CALL                  
                  long          @PrtChar_ret - @__Init      
                  long          @PrtChar - @__Init          

                  jmp           #_LMM_CALL                   '     newline
                  long          @newline_ret - @__Init      
                  long          @newline - @__Init          

                  mov           __temp2,#30                  '     pause 30
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0003                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          @__L0003 - @__Init          

                  adds          i,#1                         '  next i
                  cmps          i,#"Z" WZ, WC               
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__FOR_i_2 - @__Init        
__NEXT_i_2                                                  

                  jmp           #_LMM_CALL                   '  newline
                  long          @newline_ret - @__Init      
                  long          @newline - @__Init          

                  mov           __temp2,_1000                '  pause 1000
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0004                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          @__L0004 - @__Init          

                  jmp           #_LMM_CALL                   '  CLS
                  long          @CLS_ret - @__Init          
                  long          @CLS - @__Init              

                  mov           i,_minus20                   '  for i = -20 to 20
__FOR_i_3                                                   

                  mov           __param1,i                   '    PrtDec i
                  jmp           #_LMM_CALL                  
                  long          @PrtDec_ret - @__Init       
                  long          @PrtDec - @__Init           

                  jmp           #_LMM_CALL                   '    NewLine
                  long          @NewLine_ret - @__Init      
                  long          @NewLine - @__Init          

                                                             '    'pause 50
                  adds          i,#1                         '  next i
                  cmps          i,#20 WZ, WC                
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__FOR_i_3 - @__Init        
__NEXT_i_3                                                  


                  mov           __temp2,_1000                '  pause 1000
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0005                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          @__L0005 - @__Init          

                  jmp           #_LMM_CALL                   '  CLS
                  long          @CLS_ret - @__Init          
                  long          @CLS - @__Init              

                  mov           i,#0                         '  for i = 0 to 28
__FOR_i_4                                                   

                  mov           __param1,i                   '     CursorXY i,i
                  mov           __param2,i                  
                  jmp           #_LMM_CALL                  
                  long          @CursorXY_ret - @__Init     
                  long          @CursorXY - @__Init         

                  mov           __param1,i                   '     PrtDec i
                  jmp           #_LMM_CALL                  
                  long          @PrtDec_ret - @__Init       
                  long          @PrtDec - @__Init           

                  adds          i,#1                         '  next i
                  cmps          i,#28 WZ, WC                
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__FOR_i_4 - @__Init        
__NEXT_i_4                                                  


                  mov           __temp2,_1000                '  pause 1000
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0006                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          @__L0006 - @__Init          

                  jmp           #_LMM_CALL                   '  CLS
                  long          @CLS_ret - @__Init          
                  long          @CLS - @__Init              


                  mov           __param1,#TEXT_ofs           '  PrtStr Text
                  add           __param1,par                
                  jmp           #_LMM_CALL                  
                  long          @PrtStr_ret - @__Init       
                  long          @PrtStr - @__Init           


                  jmp           #_LMM_CALL                   '  i= Getkey
                  long          @Getkey_ret - @__Init       
                  long          @Getkey - @__Init           
                  mov           i,__param1                  


                  mov           __param1,i                   '  PrtChar i
                  jmp           #_LMM_CALL                  
                  long          @PrtChar_ret - @__Init      
                  long          @PrtChar - @__Init          


                  mov           __temp2,_1000                '  pause 1000
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0007                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          @__L0007 - @__Init          

                  jmp           #_LMM_CALL                   '  CLS
                  long          @CLS_ret - @__Init          
                  long          @CLS - @__Init              


                  jmp           #_LMM_JUMP                   '  loop
                  long          @__DO_1 - @__Init           
__LOOP_1                                                    






                  mov           __temp1,#0                   '  END
                  waitpne       __temp1,__temp1             



                                                             '' ----------------------------------------------------------------------
                                                             '' SUB/FUNC Code
                                                             '' ----------------------------------------------------------------------

Key                                                          'Func Key

                  mov           __temp1,#keybuffer_ofs       '     rdlong Keybuffer, Temp
                  add           __temp1,par                 
                  rdlong        temp,__temp1                

                  mov           temp1,temp                   '     Temp1 = Temp + 4
                  adds          temp1,#4                    


                  rdlong        temp2,temp                   '     rdlong temp, temp2  'par_tail

                  rdlong        temp3,temp1                  '     rdlong temp1, temp3 'par_head


                  cmps          temp2,temp3 WZ, WC           '     if temp2 <> temp3 then
    IF_E          jmp           #_LMM_JUMP                  
                  long          @__ELSE_1 - @__Init         

                  shl           temp2,#1                     '        temp2 = temp2*2

                  adds          temp2,temp                   '        inc temp2, temp

                  adds          temp2,#44                    '        inc temp2, 44

                  rdword        temp4,temp2                  '        rdword temp2, temp4

                  rdlong        temp2,temp                   '        rdlong temp, temp2  'par_tail

                  adds          temp2,#1                     '        inc temp2

                                                             '        temp2 = temp2 & $F
                  and           temp2,#$F                   

                  wrlong        temp2,temp                   '        wrlong temp, temp2  'par_tail

                  jmp           #_LMM_JUMP                   '     else
                  long          @__ENDIF_1 - @__Init        
__ELSE_1                                                    

                  mov           temp4,#0                     '        temp4 = 0

__ENDIF_1                                                    '     endif

                  mov           __param1,temp4               '     return temp4
                  rdlong        __PC,__PC                   
Key_ret                                                     
                  long          0-0                         

                                                             'endfunc




GetKey                                                       'Func GetKey

                                                             ''' Get next key (may wait for keypress)
                                                             ''' returns key

__DO_2                                                       '   do

                  jmp           #_LMM_CALL                   '     temp5 = Key
                  long          @Key_ret - @__Init          
                  long          @Key - @__Init              
                  mov           temp5,__param1              

                  cmps          temp5,#0 WZ, WC              '   loop until temp5 > 0
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__DO_2 - @__Init           

                  mov           __param1,temp5               '   return temp5
                  rdlong        __PC,__PC                   
GetKey_ret                                                  
                  long          0-0                         

                                                             'endfunc




















                                                             '' ################## Subs for TV:
PrtChar                                                      'SUB PrtChar 'Prints a char at the actual position

                  mov           __temp1,#screenadr_ofs       '  rdlong screenadr, screen
                  add           __temp1,par                 
                  rdlong        screen,__temp1              

                                                             '  '(color << 1 + c & 1) << 10 + $200 + c & $FE
                  mov           temp,__param1                '  TEMP = __param1 & $FE
                  and           temp,#$FE                   

                  mov           temp1,__param1               '  TEMP1 = __param1 & 1
                  and           temp1,#1                    

                                                             '  TEMP1 = TEMP1 << 10
                  shl           temp1,#10                   

                  adds          temp,temp1                   '  inc TEMP, TEMP1

                  adds          temp,_hex200                 '  inc TEMP, $200

                  mov           __temp1,row                  '  pos= 40*row
                  mov           __temp2,#40                 
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0008                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0008 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           pos,__temp1                 

                  adds          pos,col                      '  inc pos, col

                  shl           pos,#1                       '  pos = pos * 2

                  adds          pos,screen                   '  inc pos, screen

                  wrword        temp,pos                     '  wrword pos, TEMP

                  adds          col,#1                       '  inc col

                  cmps          col,#40 WZ, WC               '  if col = 40 then
    IF_NE         jmp           #_LMM_JUMP                  
                  long          @__ELSE_2 - @__Init         

                  mov           col,#0                       '    col=0

                  adds          row,#1                       '    inc row

                  jmp           #_LMM_CALL                   '    NewLine
                  long          @NewLine_ret - @__Init      
                  long          @NewLine - @__Init          

__ELSE_2                                                     '  endif
__ENDIF_2                                                   

                  rdlong        __PC,__PC                    'endsub
PrtChar_ret                                                 
                  long          0-0                         
                                                            


NewLine                                                      'SUB NewLine

                  mov           col,#0                       '  col = 0

                  adds          row,#1                       '  inc row

                  cmps          row,#29 WZ, WC               '  if row > 29 then
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__ELSE_3 - @__Init         

                  subs          row,#1                       '    dec row

                  mov           temp,#40                     '    for temp= 40 to 1199
__FOR_temp_5                                                

                  mov           temp1,temp                   '       temp1 = temp*2
                  shl           temp1,#1                    

                  mov           temp2,temp1                  '       temp2 = temp1 - 80
                  adds          temp2,_minus80              

                  adds          temp1,screen                 '       inc temp1, screen

                  adds          temp2,screen                 '       inc temp2, screen

                  rdword        temp3,temp1                  '       rdword temp1, temp3

                  wrword        temp3,temp2                  '       wrword temp2, temp3

                  adds          temp,#1                      '    next temp
                  cmps          temp,_1199 WZ, WC           
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__FOR_temp_5 - @__Init     
__NEXT_temp_5                                               

__ELSE_3                                                     '  endif
__ENDIF_3                                                   

                  mov           temp,_1160                   '  for temp = 1160 to 1199
__FOR_temp_6                                                

                  mov           temp1,temp                   '       temp1 = temp*2
                  shl           temp1,#1                    

                  adds          temp1,screen                 '       inc temp1, screen

                  wrword        _hex220,temp1                '       wrword temp1, $220

                  adds          temp,#1                      '  next temp
                  cmps          temp,_1199 WZ, WC           
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__FOR_temp_6 - @__Init     
__NEXT_temp_6                                               


                  rdlong        __PC,__PC                    'ENDSUB
NewLine_ret                                                 
                  long          0-0                         
                                                            


PrtDec                                                       'Sub PrtDec

                  mov           temp7,__param1               '    temp7 = __param1

                  cmps          temp7,#0 WZ, WC              '    if temp7 = 0 then
    IF_NE         jmp           #_LMM_JUMP                  
                  long          @__ELSE_4 - @__Init         

                  mov           __param1,#"0"                '       PrtChar "0"
                  jmp           #_LMM_CALL                  
                  long          @PrtChar_ret - @__Init      
                  long          @PrtChar - @__Init          

__ELSE_4                                                     '    endif
__ENDIF_4                                                   

                  mov           temp6,#0                     '    temp6= 0


                  cmps          temp7,#0 WZ, WC              '    if temp7 < 0 then
    IF_AE         jmp           #_LMM_JUMP                  
                  long          @__ELSE_5 - @__Init         

                  mov           __param1,#"-"                '      PrtChar "-"
                  jmp           #_LMM_CALL                  
                  long          @PrtChar_ret - @__Init      
                  long          @PrtChar - @__Init          

                  neg           temp7,temp7                  '      temp7 = -temp7

__ELSE_5                                                     '    endif
__ENDIF_5                                                   



                  mov           temp3,_1000000000            '   temp3= 1_000_000_000

                  mov           temp4,#1                     '   for temp4 = 1 to 10
__FOR_temp4_7                                               

                  cmps          temp7,temp3 WZ, WC           '     if temp7 >= temp3 then
    IF_B          jmp           #_LMM_JUMP                  
                  long          @__ELSE_6 - @__Init         

                  mov           __temp1,temp7                '       temp5 = temp7 / temp3
                  mov           __temp2,temp3               
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #_LMM_JUMP                  
                  long          @__L0009 - @__Init          
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0010                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #_LMM_JUMP                  
                  long          @__L0010 - @__Init          
                  rcr           __temp2,#1                  
__L0011                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#_LMM_JUMP          
                  long          @__L0011 - @__Init          
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0009                                                     
                  mov           temp5,__temp4               

                  adds          temp5,#"0"                   '       inc temp5 , "0"

                  mov           __param1,temp5               '       PrtChar temp5
                  jmp           #_LMM_CALL                  
                  long          @PrtChar_ret - @__Init      
                  long          @PrtChar - @__Init          

                  mov           __temp1,temp7                '       temp7 = temp7 // temp3
                  mov           __temp2,temp3               
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
__L0012                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #_LMM_JUMP                  
                  long          @__L0012 - @__Init          
                  rcr           __temp2,#1                  
                  mov           __temp4,#0                  
__L0013                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#_LMM_JUMP          
                  long          @__L0013 - @__Init          
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
                  mov           temp7,__temp1               

                  mov           temp6,#1                     '       temp6= 1

                  jmp           #_LMM_JUMP                   '     elseif temp6 > 0 then
                  long          @__ENDIF_6 - @__Init        
__ELSE_6                                                    
                  cmps          temp6,#0 WZ, WC             
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__ELSE_7 - @__Init         

                  mov           __param1,#"0"                '       PrtChar "0"
                  jmp           #_LMM_CALL                  
                  long          @PrtChar_ret - @__Init      
                  long          @PrtChar - @__Init          

__ELSE_7                                                     '     endif
__ENDIF_6                                                   

                  mov           __temp1,temp3                '     temp3 = temp3 / 10
                  mov           __temp2,#10                 
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #_LMM_JUMP                  
                  long          @__L0014 - @__Init          
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0015                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #_LMM_JUMP                  
                  long          @__L0015 - @__Init          
                  rcr           __temp2,#1                  
__L0016                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#_LMM_JUMP          
                  long          @__L0016 - @__Init          
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0014                                                     
                  mov           temp3,__temp4               

                  adds          temp4,#1                     '   next temp4
                  cmps          temp4,#10 WZ, WC            
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__FOR_temp4_7 - @__Init    
__NEXT_temp4_7                                              


                  rdlong        __PC,__PC                    'ENDSUB
PrtDec_ret                                                  
                  long          0-0                         
                                                            


CursorXY                                                     'sub CursorXY

                  mov           row,__param2                 '  row = __param2

                  mov           col,__param1                 '  col = __param1

                  rdlong        __PC,__PC                    'endsub
CursorXY_ret                                                
                  long          0-0                         
                                                            


CLS                                                          'sub CLS

                  mov           temp,#0                      '  for temp = 0 to 1199
__FOR_temp_8                                                

                  mov           temp1,temp                   '       temp1 = temp*2
                  shl           temp1,#1                    

                  adds          temp1,screen                 '       inc temp1, screen

                  wrword        _hex220,temp1                '       wrword temp1, $220

                  adds          temp,#1                      '  next temp
                  cmps          temp,_1199 WZ, WC           
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__FOR_temp_8 - @__Init     
__NEXT_temp_8                                               

                  mov           col,#0                       '  col=0

                  mov           row,#0                       '  row=0

                  rdlong        __PC,__PC                    'endsub
CLS_ret                                                     
                  long          0-0                         
                                                            


PrtStr                                                       'sub PrtStr 'Pointer to hub

                  mov           temp2,__param1               '    temp2 = __param1

                  rdbyte        temp3,temp2                  '    rdbyte temp2, temp3

__DO_3                                                       '    do while temp3 > 0
                  cmps          temp3,#0 WZ, WC             
    IF_BE         jmp           #_LMM_JUMP                  
                  long          @__LOOP_3 - @__Init         

                  mov           __param1,temp3               '       PrtChar temp3
                  jmp           #_LMM_CALL                  
                  long          @PrtChar_ret - @__Init      
                  long          @PrtChar - @__Init          

                  adds          temp2,#1                     '       inc temp2

                  rdbyte        temp3,temp2                  '       rdbyte temp2, temp3

                  jmp           #_LMM_JUMP                   '    loop
                  long          @__DO_3 - @__Init           
__LOOP_3                                                    

                  rdlong        __PC,__PC                    'endsub
PrtStr_ret                                                  
                  long          0-0                         
                                                            







                                                             '' ----------------------------------------------------------------------


                                                             '' ======================================================================
                                                             '' TASK Code
                                                             '' ======================================================================

DAT                                                         
  '-------------------------------------------------------------------------------------------
  'LMM Execution code                                       
  ' -------------------------------------------------------------------------------------------
                                                            
  ORG 0                                                     
                                                            
_LMM_Entry                                                  
                  mov           __PC,__OFFSET               
                                                            
_LMM_LOOP                                                   
                  rdlong        __INSTR1,__PC               
                  add           __PC,#4                     
__INSTR1                                                    
                  nop           ' Placeholder for LMM instruction
                                                            
                  rdlong        __INSTR2,__PC               
                  add           __PC,#4                     
__INSTR2                                                    
                  nop           ' Placeholder for LMM instruction
                                                            
                  rdlong        __INSTR3,__PC               
                  add           __PC,#4                     
__INSTR3                                                    
                  nop           ' Placeholder for LMM instruction
                                                            
                  rdlong        __INSTR4,__PC               
                  add           __PC,#4                     
__INSTR4                                                    
                  nop           ' Placeholder for LMM instruction
                                                            
                  jmp           #_LMM_LOOP                  
                                                            
_LMM_JUMP                                                   
                  rdlong        __PC,__PC                   
                  add           __PC,__OFFSET               
                  jmp           #_LMM_LOOP                  
                                                            
_LMM_CALL                                                   
                  rdlong        __temp1,__PC                
                  add           __temp1,__OFFSET            
                  add           __PC,#8                     
                  wrlong        __PC,__temp1                
                  sub           __PC,#4                     
                  rdlong        __PC,__PC                   
                  add           __PC,__OFFSET               
                  jmp           #_LMM_LOOP                  
                                                            
_LMM_MOVS                                                   
                  rdlong        __MOVS,__PC                 
                  movs          __MOVS,__INDEX              
                  add           __PC,#4                     
__MOVS                                                      
                  nop           ' Placeholder for LMM instruction
                  jmp           #_LMM_LOOP                  
                                                            
_LMM_MOVD                                                   
                  rdlong        __MOVD,__PC                 
                  movd          __MOVD,__INDEX              
                  add           __PC,#4                     
__MOVD                                                      
                  nop           ' Placeholder for LMM instruction
                  jmp           #_LMM_LOOP                  
                                                            
                  '             Variables for LMM execution code
__INDEX          LONG 0  ' Used by MOVS and MOVD            
__OFFSET         LONG 0-0' Set by spin                      
__PC             LONG 0  ' Program counter                  
'**********************************************************************
__InitDirA       LONG %00000000_00000000_00000000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
_minus80         LONG -80
_minus20         LONG -20
_hex200          LONG $200
_hex220          LONG $220
_1000            LONG 1000
_1160            LONG 1160
_1199            LONG 1199
_1mSec           LONG 80000
_FREQ            LONG 80000000
_1000000000      LONG 1_000_000_000

col              LONG 0
row              LONG 0

__remainder
__temp1          RES 1
__temp2          RES 1
__temp3          RES 1
__temp4          RES 1
__temp5          RES 1
__param1         RES 1
__param2         RES 1
__param3         RES 1
__param4         RES 1
__paramcnt       RES 1
i                RES 1
screen           RES 1
char             RES 1
pos              RES 1
temp             RES 1
temp1            RES 1
temp2            RES 1
temp3            RES 1
temp4            RES 1
temp5            RES 1
temp6            RES 1
temp7            RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  screenadr_ofs                    = 0
  keybuffer_ofs                    = 4
  TEXT_ofs                         = 8

DAT
__DATASTART
screenadr        LONG 0
keybuffer        LONG 0
TEXT
                 BYTE "This is a string. Please press a key!",0


